package layers;

import models.Layer;

import java.util.ArrayList;
import java.util.List;

public class LayerRepo implements ICreateLayer {
	private List<Layer> repo;

	public LayerRepo() {
		this.repo = new ArrayList<>();
	}

	@Override
	public ILayerList getIterator() {
		return new LayerIterator(repo);
	}

	@Override
	public void addLayer(Layer layer) {
		Layer add=layer;
		for(Layer x:repo){
			if(x.getId().equals(layer.getId())) {
				add=new Layer(layer.getId()+"#");
				add.setLayerShapes(layer.getLayerShapes());
			}
		}
		this.repo.add(add);

	}

	@Override
	public void removeLayer(String layerId) {
		for(Layer x:repo){
			if(x.getId().equals(layerId)) repo.remove(x);
		}

	}

	@Override
	public void activateLayer(String layerID) {
		Layer temp=null;
		for(Layer x:repo){
			if(x.getId().equals(layerID)) temp=x;
		}
		repo.remove(temp);
		temp.setActivation(true);
		repo.add(temp);
	}

	@Override
	public void deactivateLayer(String layerID) {
		Layer temp=null;
		for(Layer x:repo){
			if(x.getId().equals(layerID)) temp=x;
		}
		repo.remove(temp);
		temp.setActivation(false);
		repo.add(temp);
	}
}
