package management;

import exceptions.serverexceptions.HtmlParseException;
import exceptions.serverexceptions.SerializationException;
import gui.html.HtmlParsing;
import layers.LayerIterator;
import library.Colours;
import library.EditOptions;
import library.Shape_Forms;
import library.TERMS;
import operations.ManageShapes;
import serialization.ReadClientData;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.logging.Logger;

/**
 * checks all requests and redirects to Thread
 */
public class ClientHandling {
	private Logger log=Logger.getLogger(ClientHandling.class.getName());
	private String clientId;
	public ClientHandling(String id) {
		this.clientId=id;
	}
	public String getCanvasHtml(){

		return "not yet implemented";
	}
	public boolean deleteShape(String shapeId){
		try {
			ManageShapes man = new ManageShapes();
			List<String> params = new ArrayList<>();
			params.add(0, clientId);
			params.add(1, shapeId);
			man.setShapeOperation(TERMS.SHAPEDELETIONOPERATION, params);
			return true;
		} catch (Exception e) {
			log.warning(e.getClass().getName()+" in deleteShape _ msg: "+e.getMessage());
			return false;
		}
	}

	public List<String> getAllEditOptionsFromLibrary() {
		List<EditOptions> editoptions=new ArrayList<>(Arrays.asList(EditOptions.values()));
		List<String> response=new ArrayList<>();
		for(int i=0;i<EditOptions.values().length;i++){
			response.add(editoptions.get(i).toString().toLowerCase());
		}
		return response;
	}

	public List<String> getAllShapesFromLibrary() {
		List<Shape_Forms> editoptions=new ArrayList<>(Arrays.asList(Shape_Forms.values()));
		List<String> response=new ArrayList<>();
		for(int i=0;i<Shape_Forms.values().length;i++){
			response.add(editoptions.get(i).toString().toLowerCase());
		}
		return response;
	}

	public List<String> getAllColoursFromLibrary() {
		List<Colours> editoptions=new ArrayList<>(Arrays.asList(Colours.values()));
		List<String> response=new ArrayList<>();
		for(int i=0;i<Colours.values().length;i++){
			response.add(editoptions.get(i).toString().toLowerCase());
		}
		return response;
	}

	public List<String> getAllShapesFromLayer(String layerId) {
		return null;
	}

	public List<String> getAllLayerForClient() {
		List<String> response=new ArrayList<>();
		try {
			LayerIterator b= (LayerIterator) new ReadClientData(clientId).getLayerRepoOfClient().getIterator();
			while (b.hasNext()){
				response.add(b.next().getId());
			}
		} catch (SerializationException e) {
			log.warning(e.toString());
			response.add("Layers not found: "+e.getMessage());
		}
		return response;
	}

	public String editShape(String canvasId, String shapeID, String cx, String cy, String rx, String ry, String fill, String stroke, String stroke_width, String info_text) {
		return "not yet implemented";
	}

	public String getSVGDataString() {
		return "not yet implemented";
	}

	public String registerNewClient() {
		return "not yet implemented";
	}

	public String createNewLayer(String layerid) {
		return "not yet implemented";
	}

	public String createNewShape(String clientId, String type, String canvasId, String cx, String cy, String rx, String ry, String fill, String stroke, String stroke_width, String info_text) {
		ManageShapes shapeCommand=new ManageShapes();
		List<String> params=new ArrayList<>();
		params.add(TERMS.CLIENTID_INDEX,clientId);
		params.add(TERMS.CANVASID_INDEX,canvasId);
		params.add(TERMS.SHAPETYPE_INDEX,type);
		params.add(TERMS.CX_INDEX,cx);
		params.add(TERMS.CY_INDEX,cy);
		params.add(TERMS.RX_INDEX,rx);
		params.add(TERMS.RY_INDEX,ry);
		params.add(TERMS.FILL_INDEX,fill);
		params.add(TERMS.STROKE_INDEX,stroke);
		params.add(TERMS.STROKEWIDTH_INDEX,stroke_width);
		params.add(TERMS.TEXTINFO_INDEX,info_text);
		shapeCommand.setShapeOperation(TERMS.SHAPECREATIONOPERATION,params);
		ReadClientData read=new ReadClientData(clientId);
		HtmlParsing parseHtml=new HtmlParsing();
		String response=null;
		try {
			response=parseHtml.parseLayerToHtmlDoc(read.readLayer(canvasId));
		} catch (HtmlParseException | SerializationException e) {
			log.warning(e.toString());
			response="shape not created";
		}
		return response;
	}

	public String manageLayerActivity(Boolean activated, String layerId) {
		return "not yet implemented";
	}

	public String deleteAllClienteData() {
		return "not yet implemented";
	}
}
