package operations.delete;

import exceptions.serverexceptions.OperationException;
import exceptions.serverexceptions.SerializationException;
import layers.LayerIterator;
import layers.LayerRepo;
import models.Layer;
import models.shapes.IShapes;
import serialization.ReadClientData;
import serialization.SaveClientData;

import java.io.IOException;
import java.util.List;
import java.util.logging.Logger;

public class DeleteShape {
	private Logger log=Logger.getLogger(DeleteShape.class.getName());
	private String canvasId,objectId,clientId;
	public DeleteShape(List<String> params) {
		setObjectId(params.get(1));
		setCanvasId();
		setClientId(params.get(0));
	}

	public boolean deleteShape() throws OperationException {
		ReadClientData data=new ReadClientData(this.clientId);
		try {
			LayerRepo repo=data.getLayerRepoOfClient();
			LayerIterator LList= (LayerIterator) repo.getIterator();
			while(LList.hasNext()){
				Layer l=LList.next();
				List<IShapes> list=l.getLayerShapes();
				for(IShapes x:list){
					if(x.getId().equals(this.objectId)) {
						list.remove(x);
						l.setLayerShapes(list);
						repo.removeLayer(this.canvasId);
						repo.addLayer(l);
						SaveClientData save=new SaveClientData(this.clientId);
						save.SaveLayerRepository(repo);
						return true;
					}
				}
			}
		} catch (IOException e) {
			log.warning(e.toString());
			throw new OperationException("IOexception in deleteShape");
		} catch (SerializationException e) {
			log.warning(e.toString());
			throw new OperationException("exception in deleteShape");
		}
		return true;
	}

	public String getCanvasId() {
		return canvasId;
	}

	public void setCanvasId(String canvasId) {
		this.canvasId = canvasId;
	}

	public String getObjectId() {
		return objectId;
	}
	private void setCanvasId() {
		String id=getObjectId().substring(0,getObjectId().indexOf("_"));
		setCanvasId(id);
	}
	public void setObjectId(String objectId) {
		this.objectId = objectId;
	}

	public String getClientId() {
		return clientId;
	}

	public void setClientId(String clientId) {
		this.clientId = clientId;
	}
}
