package serialization;

import layers.LayerIterator;
import layers.LayerRepo;
import library.TERMS;
import models.Layer;
import models.shapes.IShapes;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;

/**
 * gets client-data
 */
public class AccessClientData {
	private String path;

	protected AccessClientData(String path) {
		this.path=path;
	}

	protected LayerRepo getLayerRepo() throws IOException, ClassNotFoundException {
		LayerRepo repo;
		FileInputStream fileIn = new FileInputStream(this.path + TERMS.SERIZALIZEDLAYERREPO);
		ObjectInputStream in = new ObjectInputStream(fileIn);
		repo = (LayerRepo) in.readObject();
		in.close();
		fileIn.close();
		return repo;
	}
	protected Layer readLayer( String layerId) throws IOException, ClassNotFoundException {
		LayerRepo repo=getLayerRepo();
		LayerIterator layerList= (LayerIterator) repo.getIterator();
		Layer layer=null;
		while(layerList.hasNext()){
			layer=layerList.next();
			if(layer.getId().toLowerCase().equals(layerId.toLowerCase())) return layer;
		}
		return null;
	}
	protected IShapes getShape(String shapeId) throws IOException, ClassNotFoundException {
		String layerID=shapeId.substring(0,shapeId.indexOf("_"));
		LayerRepo repo=getLayerRepo();
		LayerIterator it= (LayerIterator) repo.getIterator();
		Layer layer=null;
		while(it.hasNext()){
			layer=it.next();
			if(layer.getId().equals(layerID)) {
				for(IShapes x:layer.getLayerShapes()){
					if(x.getId().equals(shapeId)) return x;
				}
			}
		}
		return null;
	}

}
	/*	try {
		FileInputStream fileIn = new FileInputStream("/tmp/employee.ser");
		ObjectInputStream in = new ObjectInputStream(fileIn);
		e = (Employee) in.readObject();
		in.close();
		fileIn.close();
		} catch (IOException i) {
		i.printStackTrace();
		return;
		} catch (ClassNotFoundException c) {
		System.out.println("Employee class not found");
		c.printStackTrace();
		return;
		}*/